-- MARIANAS DANICA DYNAMIC WAR (Made by Obi of Danica, based on the "Foothold concept" missions with the ZoneCommander framework made by Dzsek)
-- Airfields, North to south: Pagan, Saipan, NorthField, Tinian, Rota, NorthWestField, Andersen, Antonio, OlfOrote, Carrier
-- FOBs:	CocoIsland, North Field, Saipan North
-----------------------------
-- Obi To-Do's:
--1--	Lav et Kneeboard med alle waypoints i missionen - Få lagt KA-50 og KA-50III ind også
--2--	Make a note of the valid Supply zones on the map: Andersen, Antonio, Rota, Tinian and Saipan
--3--	Copy/paste Waypoint liste ind i Mission Briefing - DONE
--4--	Lav en eventtrigger så man får en CAP.
--5--	Kan Andersen CAP (F-15) restrictes til ikke at lave selvmord mod Rota Air Defenses.
--6--	
--7--	Attacks som følge af Rota taget?
--8--	Attacks som følge af Carrier Gruppen taget? (Måske også for hvert upgrade level?)
--9--	
--10-	

-- Run functions to create object tables for the mission environment to run
function merge(tbls)
	local res = {}
	for i,v in ipairs(tbls) do
		for i2,v2 in ipairs(v) do
			table.insert(res,v2)
		end
	end
	
	return res
end

function allExcept(tbls, except)
	local tomerge = {}
	for i,v in pairs(tbls) do
		if i~=except then
			table.insert(tomerge, v)
		end
	end
	return merge(tomerge)
end

-- Define how many upgrade levels (1-5), and what equipment is part of the upgrade level - for every zonetype you plan to use.
CarrierUpgrades = {
	blue = {"bSub", "bFrigate", "bDestroyer", "bCruiser"},
	red = {}
}

airfield = {
	blue = { "bInfantry", "bArmor", "bSam", "bSam2", "bSam3"},
	red = {"rInfantry", "rArmor", "rSam", "rSam2", "rSam3" }
}

farp = {
	blue = {"bInfantry", "bArmor", "bSam"},
	red = {"rInfantry", "rArmor", "rSamIR", "rSam"}
}

regularzone = {
	blue = {"bInfantry", "bArmor", "bSamIR"},
	red = {"rInfantry", "rArmor", "rSamIR" }
}

islandSAM = {
	blue = {"bInfantry", "bSamIR","bSam", "bSam2" },
	red = {"rInfantry", "rSamIR", "rSam", "rSam2" }
}

specialSAM = {
	blue = {"bInfantry", "bSamIR","bArmor", "bSam3", "bSamBig" },
	red = {"rInfantry", "rSamIR", "rArmor", "rSam3", "rSamBig" }
}


convoy = {
	blue = {"bInfantry"},
	red = {"rInfantry", "rInfantry", "rArmor"}
}

cargoSpawns = {
	["Andersen"] = {"c1","c2","c3"},
	["Antonio"] = {"c4","c5","c6"},
	["RotaIntl"] = {"c7","c8","c9"},
	["Tinian"] = {"c10","c11"},
	["Saipan"] = {"c12","c13","c14"}
}


cargoAccepts = {
	Andersen =  allExcept(cargoSpawns, 'Andersen'),
	NorthWestField =  allExcept(cargoSpawns, 'NorthWestField'),
	Antonio =  allExcept(cargoSpawns, 'Antonio'),
	OlfOrote =  allExcept(cargoSpawns, 'OlfOrote'),
	CocoIsland = allExcept(cargoSpawns, 'CocoIsland'),
	RotaIntl =  allExcept(cargoSpawns, 'RotaIntl'),
	Tinian =  allExcept(cargoSpawns, 'Tinian'),
	NorthField = allExcept(cargoSpawns, 'NorthField'),
	Saipan = allExcept(cargoSpawns, 'Saipan'),
	general = allExcept(cargoSpawns)
}

-- Set flavor text for your mission waypoints/zones
flavor = {
	Andersen = 'WPT 1\nMain US Airbase in Marianas Islands and Guam.',
	NorthWestField = 'WPT 2\nWW2 airbase not used in years until the conflict broke out.\nBONUS: The base has AH-64D Apaches on hot standby.',
	Antonio = 'WPT 3\nAntonio B. Won Pat Intl. airfield used primarily for civil aviation.\nBONUS: Get an F-15 CAP when Blue controls it.',
	OlfOrote = 'WPT 4\nSmall private airfield on the Orote Peninsula in the south of Guam. \nBONUS: The Airfield has very high income from civilian flights.',
	CocoIsland = 'WPT 5\nSmall Helicopter drome and Marine base on Coco Island.',
	Carrier = 'WPT 6\nUSN Carrier Strikegroup patrolling the Pacific West of the Marianas Islands.\nBONUS: Supply the Carrier quickly to get more ships/protection.',
	RotaHill = 'WPT7\nRota Hill on the island of Rota. A major Early Warning and air defense installation.',
	RotaIntl = 'WPT8\nLarge island North of Guam main island, with Rota Intl. the local airfield.\nBONUS: The airfield has a C-130J Hercules along with a few helis.',
	AguijanIsland = 'WPT 9\nMinor island south of Tinian Island. Location of a very powerfull Early Warning Radar',
	Tinian ='WPT 10\nSmall airfield on the Tinian Island. \nBONUS: The airfield has some helicopters and attack aircraft.',
	NorthField = 'WPT 11\nWW2 Airbase, not used for years. A temporary FOB as been set up..',
	Saipan = 'WPT 12\nSaipan Intl. on the large island of Saipan. \nBONUS: No enemy SU-27 Interceptors and the airport has a number of fixed wing and rotary aircraft we can use.',
	SaipanNorth = 'WPT 13\nSaipan FOB in the northern part of the island of Saipan.',
	Pagan = 'WPT 14\nThe tiny island of Pagan far north of the main islands With a small grassy airstrip.'
	}

-- Setup the file path for pesistent status saving
local filepath = 'foothold_marianas_1.4.lua'
if lfs then 
	local dir = lfs.writedir()..'Missions/Saves/'
	lfs.mkdir(dir)
	filepath = dir..filepath
	env.info('Foothold - Save file path: '..filepath)
end
bc = BattleCommander:new(filepath, 10, 60)


-- Define all your zones on the map, which side they start as, upgrade level and more. These can be capturable or give a specific benefit or bonus.
-- Side 0 = Neutral, Side 1 = Red and Side 2 = Blue
-- The income parameter is amount of credits per tick, a tick is 10 seconds. Ie. 1 = 360 credits per hour, 2 = 720, 3 = 1080, 4 = 1440 and 5 = 1800.

Andersen = ZoneCommander:new({zone='Andersen', side=2, level=3, upgrades=airfield, crates=cargoAccepts.Andersen, flavorText=flavor.Andersen, income=1})
NorthWestField = ZoneCommander:new({zone='NorthWestField', side=0, level=2, upgrades=farp, crates=cargoAccepts.NorthWestField, flavorText=flavor.NorthWestField, income=1})
Antonio = ZoneCommander:new({zone='Antonio', side=1, level=3, upgrades=airfield, crates=cargoAccepts.Antonio, flavorText=flavor.Antonio, income=1})
OlfOrote = ZoneCommander:new({zone='OlfOrote', side=0, level=1, upgrades=farp, crates=cargoAccepts.OlfOrote, flavorText=flavor.OlfOrote, income=2})
CocoIsland = ZoneCommander:new({zone='CocoIsland', side=1, level=1, upgrades=islandSAM, crates=cargoAccepts.CocoIsland, flavorText=flavor.CocoIsland})
Carrier = ZoneCommander:new({zone='Carrier Group', side=0, level=1, upgrades=CarrierUpgrades, crates={}, flavorText=flavor.Carrier})
RotaHill = ZoneCommander:new({zone='RotaHill', side=1, level=4, upgrades=islandSAM, crates=cargoAccepts.RotaHill, flavorText=flavor.RotaHill})
RotaIntl = ZoneCommander:new({zone='RotaIntl', side=1, level=3, upgrades=airfield, crates=cargoAccepts.RotaIntl, flavorText=flavor.RotaIntl, income=1})
AguijanIsland = ZoneCommander:new({zone='AguijanIsland', side=1, level=5, upgrades=islandSAM, crates=cargoAccepts.AguijanIsland, flavorText=flavor.AguijanIsland})
Tinian = ZoneCommander:new({zone='Tinian', side=1, level=4, upgrades=airfield, crates=cargoAccepts.general, flavorText=flavor.Tinian, income=1})
NorthField = ZoneCommander:new({zone='NorthField', side=3, level=1, upgrades=farp, crates=cargoAccepts.NorthField, flavorText=flavor.NorthField})
Saipan = ZoneCommander:new({zone='Saipan', side=1, level=5, upgrades=airfield, crates=cargoAccepts.Saipan, flavorText=flavor.Saipan, income=2})
SaipanNorth = ZoneCommander:new({zone='SaipanNorth', side=0, level=2, upgrades=farp, crates=cargoAccepts.SaipanNorth, flavorText=flavor.SaipanNorth})
Pagan = ZoneCommander:new({zone='Pagan', side=1, level=3, upgrades=farp, crates=cargoAccepts.Pagan, flavorText=flavor.Pagan, income=5})

AguijanIsland:addCriticalObject('Aguijan-EWR')
RotaHill:addCriticalObject('RotaCommTower')


-- Add defined Groups in Mission Editor to your Zones in ZoneCommander
dispatch = {
	Andersen={
		GroupCommander:new({name='Andersen-bsupply-1', mission='supply', targetzone='NorthWestField'}),
		GroupCommander:new({name='Andersen-bsupply-2', mission='supply', targetzone='Antonio'}),
		GroupCommander:new({name='Andersen-bsupply-3', mission='supply', targetzone='RotaIntl'}),
		GroupCommander:new({name='Andersen-bpatrol-1', mission='patrol', targetzone='RotaHill'}),
		GroupCommander:new({name='Andersen-btanker-1', mission='patrol', targetzone='Andersen'}),
		GroupCommander:new({name='Andersen-battack-1', mission='attack', targetzone='Carrier'})
	},
	Carrier={
		GroupCommander:new({name='Carrier-bsupply-1', mission='supply', targetzone='Andersen', type='carrier_air'}),
		GroupCommander:new({name='Carrier-battack-1', mission='attack', targetzone='Andersen', type='carrier_air'}),
		GroupCommander:new({name='Carrier-btanker-1', mission='patrol', targetzone='Andersen', type='carrier_air'})
	},	
	Antonio = {
		GroupCommander:new({name='Antonio-bsupply-1', mission='supply', targetzone='Andersen'}), 		
		GroupCommander:new({name='Antonio-bsupply-2', mission='supply', targetzone='NorthWestField'}), 		
		GroupCommander:new({name='Antonio-bsupply-3', mission='supply', targetzone='OlfOrote'}), 		
		GroupCommander:new({name='Antonio-bsupply-4', mission='supply', targetzone='CocoIsland'}),
		GroupCommander:new({name='Antonio-bpatrol-1', mission='patrol', targetzone='Andersen'}),
		GroupCommander:new({name='Antonio-rattack-1', mission='attack', targetzone='OlfOrote'}),
		GroupCommander:new({name='Antonio-rattack-2', mission='attack', targetzone='Andersen'}),
		GroupCommander:new({name='Antonio-rattack-3', mission='attack', targetzone='NorthWestField'}),
		GroupCommander:new({name='Antonio-tforce-1', mission='attack', targetzone='OlfOrote', type='surface'}),
		GroupCommander:new({name='Antonio-rforce-1', mission='attack', targetzone='NorthWestField', type='surface'})
	},
	OlfOrote = {
		GroupCommander:new({name='OlfOrote-bsupply-1', mission='supply', targetzone='Antonio'}),
		GroupCommander:new({name='OlfOrote-bsupply-2', mission='supply', targetzone='CocoIsland'}),
		GroupCommander:new({name='OlfOrote-rsupply-1', mission='supply', targetzone='Antonio'}),
		GroupCommander:new({name='OlfOrote-rsupply-2', mission='supply', targetzone='CocoIsland'}),
		GroupCommander:new({name='OlfOrote-rattack-1', mission='attack', targetzone='Antonio'}),
		GroupCommander:new({name='OlfOrote-rattack-2', mission='attack', targetzone='Antonio'}),
		GroupCommander:new({name='OlfOrote-rattack-3', mission='attack', targetzone='Antonio'})
	},
	CocoIsland = {
		GroupCommander:new({name='CocoIsland-bsupply-1', mission='supply', targetzone='Antonio'}),
		GroupCommander:new({name='CocoIsland-bsupply-2', mission='supply', targetzone='OlfOrote'}),
		GroupCommander:new({name='CocoIsland-rsupply-1', mission='supply', targetzone='OlfOrote'}),
		GroupCommander:new({name='CocoIsland-rsupply-2', mission='supply', targetzone='Antonio'}),
		GroupCommander:new({name='CocoIsland-rattack-1', mission='attack', targetzone='OlfOrote'}),
		GroupCommander:new({name='CocoIsland-rattack-2', mission='attack', targetzone='Antonio'})
	},
	NorthWestField = {
		GroupCommander:new({name='NorthWestField-bsupply-1', mission='supply', targetzone='Andersen'}),
		GroupCommander:new({name='NorthWestField-bsupply-2', mission='supply', targetzone='Antonio'}),
		GroupCommander:new({name='NorthWestField-bsupply-3', mission='supply', targetzone='NorthField'})
	},
	RotaIntl = {
		GroupCommander:new({name='Rota-bsupply-1', mission='supply', targetzone='Andersen'}),
		GroupCommander:new({name='Rota-bsupply-2', mission='supply', targetzone='Tinian'}),
		GroupCommander:new({name='Rota-rsupply-1', mission='supply', targetzone='Tinian'}),
		GroupCommander:new({name='Rota-rpatrol-1', mission='patrol', targetzone='Andersen'}),
		GroupCommander:new({name='Rota-rattack-1', mission='attack', targetzone='Andersen'}),
		GroupCommander:new({name='Rota-rattack-2', mission='attack', targetzone='NorthWestField'}),
		GroupCommander:new({name='Rota-rattack-3', mission='attack', targetzone='Antonio'}),
		GroupCommander:new({name='Rota-rattack-4', mission='attack', targetzone='CocoIsland'}),
		GroupCommander:new({name='Rota-iforce-1', mission='attack', targetzone='RotaIntl', type=surface}),
		GroupCommander:new({name='Rota-tforce-1', mission='attack', targetzone='RotaIntl', type=surface}),
		GroupCommander:new({name='Rota-tforce-2', mission='attack', targetzone='RotaIntl', type=surface}),
		GroupCommander:new({name='Rota-aforce-1', mission='attack', targetzone='RotaIntl', type=surface})
	},
	Tinian = {
		GroupCommander:new({name='Tinian-bsupply-1', mission='supply', targetzone='RotaIntl'}),
		GroupCommander:new({name='Tinian-bsupply-2', mission='supply', targetzone='Taipan'}),
		GroupCommander:new({name='Tinian-rattack-1', mission='attack', targetzone='RotaHill'}),
		GroupCommander:new({name='Tinian-rattack-2', mission='attack', targetzone='Carrier'}),
		GroupCommander:new({name='Tinian-rattack-3', mission='attack', targetzone='RotaIntl'}),
		GroupCommander:new({name='Tinian-rattack-4', mission='attack', targetzone='RotaHill'})
	},
	Saipan = {
		GroupCommander:new({name='Saipan-bsupply-1', mission='supply', targetzone='Tinian'}),
		GroupCommander:new({name='Saipan-bsupply-2', mission='supply', targetzone='NorthField'}),
		GroupCommander:new({name='Saipan-bsupply-3', mission='supply', targetzone='Pagan'}),
		GroupCommander:new({name='Saipan-rsupply-1', mission='supply', targetzone='SaipanNorth'}),
		GroupCommander:new({name='Saipan-rsupply-2', mission='supply', targetzone='Tinian'}),
		GroupCommander:new({name='Saipan-rpatrol-1', mission='patrol', targetzone='Tinian'}),
		GroupCommander:new({name='Saipan-rpatrol-2', mission='patrol', targetzone='RotaIntl'}),
		GroupCommander:new({name='Saipan-rattack-1', mission='attack', targetzone='SaipanNorth'}),
		GroupCommander:new({name='Saipan-rattack-2', mission='attack', targetzone='Tinian'})
	},
	SaipanNorth = {
		GroupCommander:new({name='SaipanNorth-rsupply-1', mission='supply', targetzone='Saipan'}),
		GroupCommander:new({name='SaipanNorth-rattack-1', mission='attack', targetzone='Saipan'})
	},
	Pagan = {
		GroupCommander:new({name='Pagan-rattack-1', mission='attack', targetzone='Saipan'}),
		GroupCommander:new({name='Pagan-rattack-2', mission='attack', targetzone='Saipan'}),
		GroupCommander:new({name='Pagan-rattack-3', mission='attack', targetzone='SaipanNorth'}),
		GroupCommander:new({name='Pagan-rattack-4', mission='attack', targetzone='SaipanNorth'}),
		GroupCommander:new({name='Pagan-rattack-5', mission='attack', targetzone='Saipan'}),
		GroupCommander:new({name='Pagan-rattack-6', mission='attack', targetzone='SaipanNorth'})
	},
}

-- Add defined Groups in Mission Editor to your Zones in ZoneCommander
Andersen:addGroups(dispatch.Andersen)
Carrier:addGroups(dispatch.Carrier)
Antonio:addGroups(dispatch.Antonio)
OlfOrote:addGroups(dispatch.OlfOrote)
CocoIsland:addGroups(dispatch.CocoIsland)
RotaIntl:addGroups(dispatch.RotaIntl)
Tinian:addGroups(dispatch.Tinian)
Saipan:addGroups(dispatch.Saipan)
SaipanNorth:addGroups(dispatch.SaipanNorth)

-- Add defined Zones in Mission Editor to ZoneCommander
bc:addZone(Andersen)
bc:addZone(Carrier)
bc:addZone(NorthWestField)
bc:addZone(Antonio)
bc:addZone(OlfOrote)
bc:addZone(CocoIsland)
bc:addZone(RotaHill)
bc:addZone(RotaIntl)
bc:addZone(AguijanIsland)
bc:addZone(Tinian)
bc:addZone(NorthField)
bc:addZone(Saipan)
bc:addZone(SaipanNorth)
bc:addZone(Pagan)

-- Add connections between zones to give players an overview of the tactical advancement options and supply routes
bc:addConnection("Andersen","NorthWestField")
bc:addConnection("Andersen","Antonio")
bc:addConnection("Andersen","RotaIntl")
bc:addConnection("Carrier Group","NorthWestField")
bc:addConnection("Carrier Group","RotaIntl")
bc:addConnection("Carrier Group","NorthField")
bc:addConnection("NorthWestField","Antonio")
bc:addConnection("Antonio","OlfOrote")
bc:addConnection("Antonio","CocoIsland")
bc:addConnection("OlfOrote","CocoIsland")
bc:addConnection("RotaIntl","Tinian")
bc:addConnection("RotaIntl","RotaHill")
bc:addConnection("Tinian","AguijanIsland")
bc:addConnection("Tinian","Saipan")
bc:addConnection("Tinian","NorthField")
bc:addConnection("Saipan","NorthField")
bc:addConnection("Saipan","SaipanNorth")
bc:addConnection("Saipan","Pagan")


local showCredIncrease = function(event, sender)
	trigger.action.outTextForCoalition(sender.side, '+'..math.floor(sender.income*360)..' Credits/Hour', 5)
end


-------------------------------------------------------------------------------------------------------------------------------------
-- Event triggers using the following format:
-- exampleZone:registerTrigger('eventname', function(event, sender) trigger.action.outText('event triggered',5) end, 'triggerid', 4)
-- bc:fireAtZone(target, 'cruise1', true, 8)
-------------------------------------------------------------------------------------------------------------------------------------
Andersen:registerTrigger('captured', showCredIncrease, 'Andersencaptured')


NorthWestField:registerTrigger('captured', function(event,sender)
	local kr = bc:getZoneByName('NorthWestField')
	if kr.side == 2 then 
		mist.respawnGroup('Red-Strat-Bombing-1', 120)
		trigger.action.outTextForCoalition(2, 'The enemy has launched an assault on Guam after the capture of NorthWestField.', 15)
		if mist.groupIsDead('Red-Strat-Bombing-1') == true then
			mist.respawnGroup('Red-Strat-Bombing-1', 120)
		end
	end
end, 'NorthWestFieldcaptured')

Antonio:registerTrigger('captured', function(event,sender)
	local kr = bc:getZoneByName('Antonio')
	if kr.side == 2 then 
		mist.respawnGroup('Red-Strat-Bombing-2', 120)
		trigger.action.outTextForCoalition(2, 'The enemy has launched an assault on the captured Antonio Intl. Airport.', 15)
		if mist.groupIsDead('Red-Strat-Bombing-2') == true then
			mist.respawnGroup('Red-Strat-Bombing-2', 120)
		end
	end
end, 'Antoniocaptured')

OlfOrote:registerTrigger('captured', function(event,sender)
	local kr = bc:getZoneByName('OlfOrote')
	if kr.side == 2 then 
		mist.respawnGroup('Red-Strat-Bombing-3', 120)
		trigger.action.outTextForCoalition(2, 'The enemy has launched an assault on Guam after the capture of Olf Orote.', 15)
		if mist.groupIsDead('Red-Strat-Bombing-3') == true then
			mist.respawnGroup('Red-Strat-Bombing-3', 120)
		end
	end
end, 'OlfOrotecaptured')

CocoIsland:registerTrigger('captured', function(event,sender)
	local kr = bc:getZoneByName('CocoIsland')
	if kr.side == 2 then 
		mist.respawnGroup('Red-Strat-Bombing-4', 120)
		trigger.action.outTextForCoalition(2, 'The enemy has launched an assault on Guam after the capture of Coco Island.', 15)
		if mist.groupIsDead('Red-Strat-Bombing-4') == true then
			mist.respawnGroup('Red-Strat-Bombing-4', 120)
		end
	end
end, 'CocoIslandcaptured')


RotaHill:registerTrigger('destroyed', function(event, sender) 
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'Rota Hill Comms Tower disabled\n+500 credits',20)
end, 'disableRotaHill')


AguijanIsland:registerTrigger('destroyed', function(event, sender) 
	bc:addFunds(2,500)
	mist.respawnGroup('Red-Strat-Bombing-5', 120)
	if mist.groupIsDead('Red-Strat-Bombing-5') == true then
			mist.respawnGroup('Red-Strat-Bombing-5', 120)
	end
	trigger.action.outTextForCoalition(2,'Aguijan Island disabled\n+500 credits',20)
end, 'disableAguijanIsland')


RotaIntl:registerTrigger('captured', function(event,sender)
	local kr = bc:getZoneByName('RotaIntl')
	if kr.side == 2 then
		local Rotaforces = { 'Rota-iforce-1','Rota-tforce-1','Rota-tforce-2','Rota-aforce-1' }
		for _,v in ipairs(Rotaforces) do
			local g = Group.getByName(v)
			if g then
				g:destroy()
			end
		end
	end
end, 'RotaIntlcaptured')

Tinian:registerTrigger('lost', function(event,sender)
	local kr = bc:getZoneByName('Tinian')
	if kr.side == 2 then 
		mist.respawnGroup('Pagan-rattack-5', 120)
		trigger.action.outTextForCoalition(2, 'The enemy has launched an assault on our forces at Tinian Island.', 15)
		if mist.groupIsDead('Pagan-rattack-5') == true then
			mist.respawnGroup('Pagan-rattack-5', 120)
		end
	end
end, 'Tinianlost')

Tinian:registerTrigger('captured', function(event,sender)
	local kr = bc:getZoneByName('Tinian')
	if kr.side == 2 then 
		mist.respawnGroup('Red-Strat-Bombing-6', 120)
		trigger.action.outTextForCoalition(2, 'The enemy has launched an assault on Guam after the capture of Tinian Intl.', 15)
		if mist.groupIsDead('Red-Strat-Bombing-6') == true then
			mist.respawnGroup('Red-Strat-Bombing-6', 120)
		end
	end
end, 'Tiniancaptured')


NorthField:registerTrigger('captured', function(event,sender)
	local kr = bc:getZoneByName('NorthField')
	if kr.side == 2 then 
		mist.respawnGroup('Pagan-rattack-1', 120)
		trigger.action.outTextForCoalition(2, 'The enemy has launched an assault on our forces at Saipan Island.', 15)
		if mist.groupIsDead('Pagan-rattack-1') == true then
			mist.respawnGroup('Pagan-rattack-1', 120)
		end
	end
end, 'NortFieldcaptured')


Saipan:registerTrigger('lost', function(event,sender)
	local kr = bc:getZoneByName('Saipan')
	if kr.side == 2 then 
		mist.respawnGroup('Pagan-rattack-6', 120)
		trigger.action.outTextForCoalition(2, 'The enemy has launched an assault on our forces at Saipan Island.', 15)
		if mist.groupIsDead('Pagan-rattack-6') == true then
			mist.respawnGroup('Pagan-rattack-6', 120)
		end
	end
end, 'Saipanlost')

Saipan:registerTrigger('captured', function(event,sender)
	local kr = bc:getZoneByName('Saipan')
	if kr.side == 2 then 
		mist.respawnGroup('Pagan-rattack-3', 120)
		trigger.action.outTextForCoalition(2, 'The enemy has launched an assault on our forces at Saipan Island.', 15)
		if mist.groupIsDead('Pagan-rattack-3') == true then
			mist.respawnGroup('Pagan-rattack-3', 120)
		end
	end
end, 'Saipancaptured')

SaipanNorth:registerTrigger('lost', function(event,sender)
	local kr = bc:getZoneByName('SaipanNorth')
	if kr.side == 2 then 
		mist.respawnGroup('Pagan-rattack-2', 120)
		trigger.action.outTextForCoalition(2, 'The enemy has launched an assault on our forces at Saipan Island.', 15)
		if mist.groupIsDead('Pagan-rattack-2') == true then
			mist.respawnGroup('Pagan-rattack-2', 120)
		end
	end
end, 'SaipanNorthlost')

SaipanNorth:registerTrigger('captured', function(event,sender)
	local kr = bc:getZoneByName('SaipanNorth')
	if kr.side == 2 then 
		mist.respawnGroup('Pagan-rattack-4', 120)
		trigger.action.outTextForCoalition(2, 'The enemy has launched an assault on our forces at Saipan Island.', 15)
		if mist.groupIsDead('Pagan-rattack-4') == true then
			mist.respawnGroup('Pagan-rattack-4', 120)
		end
	end
end, 'SaipanNorthcaptured')

-------------------------------------------------------------------------------------------------------------------------------
-- End of the Trigger section--------------------------------------------------------------------------------------------------
-- Start of original script----------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

local checkMissionComplete = function (event, sender)
	local done = true
	for i,v in ipairs(bc:getZones()) do
		if v.side == 1 then
			done = false
			break
		end
	end
	
	if done then
		trigger.action.outText("Enemy has been defeated. \n\nMission Complete.", 120)
	end
end

for i,v in ipairs(bc:getZones()) do
	v:registerTrigger('lost', checkMissionComplete, 'missioncompleted')
end

--bc:addFunds(1,0)
--bc:addFunds(2,0)

-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('sead1'):destroy()
local seadTargetMenu = nil
bc:registerShopItem('sead', 'F/A-18C SEAD mission', 500, function(sender) 
	local gr = Group.getByName('sead1')
	if Utils.isGroupActive(gr) then 
		return 'SEAD mission still in progress'
	end
	mist.respawnGroup('sead1', true)
	
	if seadTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local launchAttack = function(target)
		if Group.getByName('sead1') then
			local err = bc:engageZone(target, 'sead1')
			if err then
				return err
			end
			
			trigger.action.outTextForCoalition(2, 'F/A-18C Hornets engaging SAMs at '..target, 15)
		else
			trigger.action.outTextForCoalition(2, 'Group has left the area or has been destroyed', 15)
		end
		
		seadTargetMenu = nil
	end
	
	seadTargetMenu = bc:showTargetZoneMenu(2, 'SEAD Target', launchAttack, 1)
	
	trigger.action.outTextForCoalition(2, 'F/A-18C Hornets on route. Choose target zone from F10 menu', 15)
end,
function (sender, params)
	if params.zone and params.zone.side == 1 then
		local gr = Group.getByName('sead1')
		if Utils.isGroupActive(gr) then 
			return 'SEAD mission still in progress'
		end
		
		mist.respawnGroup('sead1', true)
		mist.scheduleFunction(function(target)
			if Group.getByName('sead1') then
				local err = bc:engageZone(target, 'sead1')
				if err then
					return err
				end
				
				trigger.action.outTextForCoalition(2, 'F/A-18C Hornets engaging SAMs at '..target, 15)
			end
		end,{params.zone.zone},timer.getTime()+2)
	else
		return 'Can only target enemy zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('sweep1'):destroy()
bc:registerShopItem('sweep', 'F-14B Fighter Sweep', 250, function(sender) 
	local gr = Group.getByName('sweep1')
	if Utils.isGroupActive(gr) then 
		return 'Fighter sweep mission still in progress'
	end
	mist.respawnGroup('sweep1', true)
end,
function (sender, params)
	local gr = Group.getByName('sweep1')
	if Utils.isGroupActive(gr) then 
		return 'Fighter sweep mission still in progress'
	end
	mist.respawnGroup('sweep1', true)
end)
-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('antiship1'):destroy()
bc:registerShopItem('antiship', 'F/A-18 Anti-ship mission', 500, function(sender) 
	local gr = Group.getByName('antiship1')
	if Utils.isGroupActive(gr) then 
		return 'Anti-ship mission still in progress'
	end
	mist.respawnGroup('antiship1', true)
end,
function (sender, params)
	local gr = Group.getByName('antiship1')
	if Utils.isGroupActive(gr) then 
		return 'Anti-ship mission still in progress'
	end
	mist.respawnGroup('antiship', true)
end)
-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('cas1'):destroy()
local casTargetMenu = nil
bc:registerShopItem('cas', 'F-4 Ground Attack', 500, function(sender) 
	local gr = Group.getByName('cas1')
	if Utils.isGroupActive(gr) then 
		return 'Ground attack mission still in progress'
	end
	
	mist.respawnGroup('cas1', true)
	
	if casTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local launchAttack = function(target)
		if casTargetMenu then
			if Group.getByName('cas1') then
				local err = bc:engageZone(target, 'cas1')
				if err then
					return err
				end
				
				trigger.action.outTextForCoalition(2, 'F-4 Phantoms engaging groups at '..target, 15)
			else
				trigger.action.outTextForCoalition(2, 'Group has left the area or has been destroyed', 15)
			end
			
			casTargetMenu = nil
		end
	end
	
	casTargetMenu = bc:showTargetZoneMenu(2, 'F-4 Target', launchAttack, 1)
	
	trigger.action.outTextForCoalition(2, 'F-4 Phantoms on route. Choose target zone from F10 menu', 15)
end,
function (sender, params)
	if params.zone and params.zone.side == 1 then
		local gr = Group.getByName('cas1')
		if Utils.isGroupActive(gr) then 
			return 'Ground attack mission still in progress'
		end
		
		mist.respawnGroup('cas1', true)
		mist.scheduleFunction(function(target)
			if Group.getByName('cas1') then
				local err = bc:engageZone(target, 'cas1')
				if err then
					return err
				end
				
				trigger.action.outTextForCoalition(2, 'F-4 Phantoms engaging groups at '..target, 15)
			end
		end,{params.zone.zone},timer.getTime()+2)
	else
		return 'Can only target enemy zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------

bc:addMonitoredROE('cruise1')
local cruiseMissileTargetMenu = nil
bc:registerShopItem('cruisemsl', 'Cruise Missile Strike', 500, function(sender)
	if cruiseMissileTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local launchAttack = function(target)
		if cruiseMissileTargetMenu then
			local err = bc:fireAtZone(target, 'cruise1', true, 8)
			if err then
				return err
			end
			
			cruiseMissileTargetMenu = nil
			trigger.action.outTextForCoalition(2, 'Launching cruise missiles at '..target, 15)
		end
	end
	
	cruiseMissileTargetMenu = bc:showTargetZoneMenu(2, 'Cruise Missile Target', launchAttack, 1)
	
	trigger.action.outTextForCoalition(2, 'Cruise missiles ready. Choose target zone from F10 menu', 15)
end,
function (sender, params)
	if params.zone and params.zone.side == 1 then
		local err = bc:fireAtZone(params.zone.zone, 'cruise1', true, 8)
		if err then
			return err
		end
		
		trigger.action.outTextForCoalition(2, 'Launching cruise missiles at '..params.zone.zone, 15)
	else
		return 'Can only target enemy zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
local upgradeMenu = nil
bc:registerShopItem('supplies', 'Resupply friendly Zone', 1000, function(sender)
	if upgradeMenu then
	return 'Choose zone from F10 menu'
	end
	
	local upgradeZone = function(target)
		if upgradeMenu then
			local zn = bc:getZoneByName(target)
			if zn and zn.side==2 then
				zn:upgrade()
			else
				return 'Zone not friendly'
			end
			
			upgradeMenu = nil
		end
	end
	
	upgradeMenu = bc:showTargetZoneMenu(2, 'Select Zone to resupply', upgradeZone, 2)
	
	trigger.action.outTextForCoalition(2, 'Supplies prepared. Choose zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		params.zone:upgrade()
	else
		return 'Can only target friendly zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('jtacDrone'):destroy()
local jtacTargetMenu = nil
drone = JTAC:new({name = 'jtacDrone'})
bc:registerShopItem('jtac', 'MQ-1A Predator JTAC mission', 250, function(sender)
	
	if jtacTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local spawnAndOrbit = function(target)
		if jtacTargetMenu then
			local zn = bc:getZoneByName(target)
			drone:deployAtZone(zn)
			drone:showMenu()
			trigger.action.outTextForCoalition(2, 'Predator drone deployed over '..target, 15)
			jtacTargetMenu = nil
		end
	end
	
	jtacTargetMenu = bc:showTargetZoneMenu(2, 'Deploy JTAC', spawnAndOrbit, 1)
	
	trigger.action.outTextForCoalition(2, 'Choose which zone to deploy JTAC at from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 1 then
		drone:deployAtZone(params.zone)
		drone:showMenu()
		trigger.action.outTextForCoalition(2, 'Predator drone deployed over '..params.zone.zone, 15)
	else
		return 'Can only target enemy zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
local smoketargets = function(tz)
	local units = {}
	for i,v in pairs(tz.built) do
		local g = Group.getByName(v)
		for i2,v2 in ipairs(g:getUnits()) do
			table.insert(units, v2)
		end
	end
	
	local tgts = {}
	for i=1,3,1 do
		if #units > 0 then
			local selected = math.random(1,#units)
			table.insert(tgts, units[selected])
			table.remove(units, selected)
		end
	end
	
	for i,v in ipairs(tgts) do
		local pos = v:getPosition().p
		trigger.action.smoke(pos, 1)
	end
end

local smokeTargetMenu = nil
bc:registerShopItem('smoke', 'Smoke markers', 20, function(sender)
	if smokeTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local launchAttack = function(target)
		if smokeTargetMenu then
			local tz = bc:getZoneByName(target)
			smoketargets(tz)
			smokeTargetMenu = nil
			trigger.action.outTextForCoalition(2, 'Targets marked with RED smoke at '..target, 15)
		end
	end
	
	smokeTargetMenu = bc:showTargetZoneMenu(2, 'Smoke marker target', launchAttack, 1)
	
	trigger.action.outTextForCoalition(2, 'Choose target zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 1 then
		smoketargets(params.zone)
		trigger.action.outTextForCoalition(2, 'Targets marked with RED smoke at '..params.zone.zone, 15)
	else
		return 'Can only target enemy zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
local spawnAwacs = function(sender) 
	local gr = Group.getByName('awacs1')
	if Utils.isGroupActive(gr) then 
		return 'Darkstar still active on 252.00 MHz AM'
	end
	mist.respawnGroup('awacs1', true)
	trigger.action.outTextForCoalition(2,'Darkstar active on 252.00 MHz AM',15)
end
Group.getByName('awacs1'):destroy()
bc:registerShopItem('awacs', 'AWACS', 100, spawnAwacs, spawnAwacs)
-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('ewAircraft'):destroy()
local jamMenu = nil
bc:registerShopItem('jam', 'Jam radars at zone', 500, function(sender)
	local gr = Group.getByName('ewAircraft')
	if Utils.isGroupActive(gr) then 
		return 'Jamming mission still in progress'
	end
	
	mist.respawnGroup('ewAircraft', true)
	
	if jamMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local startJam = function(target)
		if jamMenu then
			bc:jamRadarsAtZone('ewAircraft', target)
			jamMenu = nil
			trigger.action.outTextForCoalition(2, 'Growler jamming radars at '..target, 15)
		end
	end
	
	jamMenu = bc:showTargetZoneMenu(2, 'Jamming target', startJam, 1)
	trigger.action.outTextForCoalition(2, 'Choose target zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 1 then
		local gr = Group.getByName('ewAircraft')
		if Utils.isGroupActive(gr) then 
			return 'Jamming mission still in progress'
		end
		
		mist.respawnGroup('ewAircraft', true)
		
		mist.scheduleFunction(function(target)
			local ew = Group.getByName('ewAircraft')
			if ew then
				local err = bc:jamRadarsAtZone('ewAircraft', target)
				if err then
					return err
				end
				
				trigger.action.outTextForCoalition(2, 'Growler jamming radars at '..target, 15)
			end
		end,{params.zone.zone},timer.getTime()+2)
		
	else
		return 'Can only target enemy zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
tanksMenu = nil
bc:registerShopItem('armor', 'Deploy armor (for combined arms)', 100, function(sender)
	
	if tanksMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployTanks = function(target)
		if tanksMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-tanks')
			
			tanksMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly armor deployed at '..target, 15)
		end
	end
	
	tanksMenu = bc:showTargetZoneMenu(2, 'Deploy armor (Choose friendly zone)', deployTanks, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-tanks')
		trigger.action.outTextForCoalition(2, 'Friendly armor deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
artyMenu = nil
bc:registerShopItem('artillery', 'Deploy artillery (for combined arms)', 100, function(sender)
	
	if artyMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployArty = function(target)
		if artyMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-arty')
			
			artyMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly artillery deployed at '..target, 15)
		end
	end
	
	artyMenu = bc:showTargetZoneMenu(2, 'Deploy artillery (Choose friendly zone)', deployArty, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-arty')
		trigger.action.outTextForCoalition(2, 'Friendly artillery deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
reconMenu = nil
bc:registerShopItem('recon', 'Deploy recon group (for combined arms)', 50, function(sender)
	
	if reconMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployRecon = function(target)
		if reconMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-recon')
			
			reconMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly recon group deployed at '..target, 15)
		end
	end
	
	reconMenu = bc:showTargetZoneMenu(2, 'Deploy recon group (Choose friendly zone)', deployRecon, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-recon')
		trigger.action.outTextForCoalition(2, 'Friendly recon group deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
airdefMenu = nil
bc:registerShopItem('airdef', 'Deploy air defence (for combined arms)', 150, function(sender)
	
	if airdefMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployAirDef = function(target)
		if airdefMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-airdef')
			
			airdefMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly air defence deployed at '..target, 15)
		end
	end
	
	airdefMenu = bc:showTargetZoneMenu(2, 'Deploy air defence (Choose friendly zone)', deployAirDef, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-airdef')
		trigger.action.outTextForCoalition(2, 'Friendly air defence deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)
-------------------------------------------------------------------------------------------------------------------------------
bc:addShopItem(2, 'sweep', -1)
bc:addShopItem(2, 'antiship', -1)
bc:addShopItem(2, 'sead', -1)
bc:addShopItem(2, 'cas', -1)
bc:addShopItem(2, 'cruisemsl', 12)
bc:addShopItem(2, 'supplies', -1)
bc:addShopItem(2, 'jtac', -1)
bc:addShopItem(2, 'smoke', -1)
bc:addShopItem(2, 'jam', -1)
bc:addShopItem(2, 'awacs', -1)

bc:addShopItem(2, 'armor', -1)
bc:addShopItem(2, 'artillery', -1)
bc:addShopItem(2, 'recon', -1)
bc:addShopItem(2, 'airdef', -1)
bc:addShopItem(2, 'antiship', -1)
-------------------------------------------------------------------------------------------------------------------------------
--red support------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------
Group.getByName('redcas1'):destroy()
bc:registerShopItem('redcas1', 'Red Cas', 1000, function(sender) 
	local gr = Group.getByName('redcas1')
	if gr and gr:getSize()>0 and gr:getController():hasTask() then 
		return 'still alive'
	end
	mist.respawnGroup('redcas1', true)
	trigger.action.outTextForCoalition(2,'The enemy has deployed a couple of Su-34 against our ground forces',15)
end)

Group.getByName('redcap1'):destroy()
bc:registerShopItem('redcap1', 'Red Cap', 1000, function(sender) 
	local gr = Group.getByName('redcap1')
	if gr and gr:getSize()>0 and gr:getController():hasTask() then 
		return 'still alive'
	end
	mist.respawnGroup('redcap1', true)
	trigger.action.outTextForCoalition(2,'Enemy MiG-31 interceptors, coming in from the North-East',15)
end)

Group.getByName('redsead1'):destroy()
bc:registerShopItem('redsead1', 'Red Sead', 1000, function(sender) 
	local gr = Group.getByName('redsead1')
	if gr and gr:getSize()>0 and gr:getController():hasTask() then 
		return 'still alive'
	end
	mist.respawnGroup('redsead1', true)
	trigger.action.outTextForCoalition(2,'The enemy has launched an attack from the North-East on our air defenses',15)
end)

Group.getByName('redmlrs1'):destroy()
bc:registerShopItem('redmlrs1', 'spawn Red mlrs', 1000, function(sender) 
	local zn = bc:getZoneByName('OlfOrote')
	if zn.side == 1 and zn.active then
		local gr = Group.getByName('redmlrs1')
		if gr then
			local full = true
			for i,v in ipairs(gr:getUnits()) do
				for i2,v2 in ipairs(v:getAmmo()) do
					if v2.count < 3 then
						full = false
						break
					end
				end
				
				if not full then 
					break
				end
			end
			
			if full and gr:getSize()==gr:getInitialSize() then
				return 'ammo full'
			end
			
			trigger.action.outTextForCoalition(2,'The enemy has resupplied its artillery near OlfOrote',15)
		end
		
		mist.respawnGroup('redmlrs1')
		bc:removeShopItem(1,'redmlrs1fire')
		bc:addShopItem(1, 'redmlrs1fire', 3)
	else
		return 'zone not red'
	end
end)

bc:registerShopItem('redmlrs1fire', 'fire red mlrs', 200, function(sender) 
	local gr = Group.getByName('redmlrs1')
	if gr then
		local targetzones = {'Saipan', 'Tinian', 'RotaIntl', 'Andersen'}
		local viabletargets = {}
		for i,v in ipairs(targetzones) do
			local z = bc:getZoneByName(v)
			
			if z and z.side == 2 then
				table.insert(viabletargets, v)
			end
		end

		if #viabletargets==0 then
			return 'no targets'
		end
		
		local targetzn = viabletargets[math.random(1,#viabletargets)]
		
		local err = bc:fireAtZone(targetzn, 'redmlrs1', true, 3, 6)
		
		if not err then
			trigger.action.outTextForCoalition(2,'Enemy artillery near OlfOrote has begun preparations to fire on '..targetzn,15)
		else
			return err
		end
	else
		return 'buy first'
	end
end)


Group.getByName('intercept1'):destroy()
Group.getByName('intercept2'):destroy()
local cargoDieEvent = nil
bc:registerShopItem('intercept1', 'Red intercept', 1000, function(sender) 
	local grt = Group.getByName('intercept1')
	local gre = Group.getByName('intercept2')
	if gre and gre:getSize()>0 and gre:getController():hasTask() then 
		return 'still alive'
	end
	
	if grt and grt:getSize()>0 and grt:getController():hasTask() then 
		return 'still alive'
	end
	
	mist.respawnGroup('intercept1', true)
	mist.respawnGroup('intercept2', true)
	
	if not cargoDieEvent then
		local cargoPlaneDied = function(event)
			if event.id==28 then
				if event.initiator and event.initiator:getCoalition()==2 and event.target and event.target.getName then
					if event.target:getName()=='intercept1' then
						trigger.action.outTextForCoalition(2,'Enemy cargo transport destroyed.\n+500 credits',15)
						bc:addFunds(2,500)
						mist.removeEventHandler(cargoDieEvent)
						cargoDieEvent = nil
					elseif not Unit.getByName('intercept1') then
						mist.removeEventHandler(cargoDieEvent)
						cargoDieEvent = nil
					end
				end
			end
		end
		
		cargoDieEvent = mist.addEventHandler(cargoPlaneDied)
	end
end)

Group.getByName('escort1'):destroy()
Group.getByName('antiescort1'):destroy()
Group.getByName('antiescort2'):destroy()
bc:registerShopItem('escort1', 'Red antiescort', 1000, function(sender) 
	local gr = Group.getByName('escort1')
	if gr and gr:getSize()>0 and gr:getController():hasTask() then 
		return 'still alive'
	end
	
	mist.respawnGroup('escort1', true)
	
	local spawnIntercept = function(groupname)
		if Group.getByName('escort1') then
			local g = Group.getByName(groupname)
			if not g then
				if math.random(1,100) > 30 then
					if math.random(1,100) > 50 then
						trigger.action.outTextForCoalition(2,'Enemy interceptor spotted heading for our cargo transport.',15)
					else
						trigger.action.outTextForCoalition(2,'The enemy has launched an intercept mission against our cargo transport',15)
					end
					mist.respawnGroup(groupname, true)
				end
			end
		end
	end
	
	local timers = {math.random(3*60,15*60), math.random(8*60,15*60)}
	mist.scheduleFunction(spawnIntercept, {'antiescort1'}, timer.getTime()+timers[1])
	mist.scheduleFunction(spawnIntercept, {'antiescort2'}, timer.getTime()+timers[2])
end)


bc:addShopItem(1, 'redcas1', -1)
bc:addShopItem(1, 'redcap1', -1)
bc:addShopItem(1, 'redsead1', -1)
bc:addShopItem(1, 'redmlrs1', -1)
bc:addShopItem(1, 'intercept1', -1)
bc:addShopItem(1, 'escort1', -1)

budgetAI = BudgetCommander:new({ battleCommander = bc, side=1, decissionFrequency=20*60, decissionVariance=10*60, skipChance = 10})
budgetAI:init()
--end red support

lc = LogisticCommander:new({battleCommander = bc, supplyZones = {'Saipan', 'RotaIntl', 'Andersen', 'Antonio', 'Tinian', 'Carrier Group'}})
lc:init()


bc:loadFromDisk() --will load and overwrite default zone levels, sides, funds and available shop items
bc:init()
bc:startRewardPlayerContribution(15,{infantry = 5, ground = 15, sam = 30, airplane = 30, ship = 200, helicopter=40, crate=100, rescue = 50})

HercCargoDropSupply.init(bc)

mc = MissionCommander:new({side = 2, battleCommander = bc, checkFrequency = 60})

mc:trackMission({
	title = "Escort",
	description = "Friendly cargo transport has entered the airspace from the south. Protect it from the enemy.",
	messageStart = "New mission: Escort",
	messageEnd = "Mission ended: Escort",
	startAction = function() trigger.action.outSoundForCoalition(2,"ding.ogg") end,
	endAction = function() 
		trigger.action.outSoundForCoalition(2,"cancel.ogg")
	end,
	isActive = function()
		if Group.getByName('escort1') then return true end
		
		return false
	end
})

mc:trackMission({
	title = "Intercept",
	description = "Enemy cargo transport has entered the airspace from the south. Intercept and destroy it before it escapes.",
	messageStart = "New mission: Intercept",
	messageEnd = "Mission ended: Intercept",
	startAction = function() trigger.action.outSoundForCoalition(2,"ding.ogg") end,
	endAction = function() 
		trigger.action.outSoundForCoalition(2,"cancel.ogg")
	end,
	isActive = function()
		if Group.getByName('intercept1') then return true end
		
		return false
	end
})

mc:trackMission({
	title = "Destroy artillery",
	description = "The enemy has deployed artillery near OlfOrote. Destroy it before it has a chance to fire",
	messageStart = "New mission: Destroy artillery",
	messageEnd = "Mission ended: Destroy artillery",
	startAction = function() trigger.action.outSoundForCoalition(2,"ding.ogg") end,
	endAction = function() 
		trigger.action.outSoundForCoalition(2,"cancel.ogg")
	end,
	isActive = function()
		if Group.getByName('redmlrs1') then return true end
		
		return false
	end
})



resupplyTarget = nil
mc:trackMission({
	title = function() return "Resupply "..resupplyTarget end,
	description = function() return "Deliver supplies to "..resupplyTarget end,
	messageStart = function() return "New mission: Resupply "..resupplyTarget end,
	messageEnd = function() return "Mission ended: Resupply "..resupplyTarget end,
	startAction = function() trigger.action.outSoundForCoalition(2,"ding.ogg") end,
	endAction = function() 
		resupplyTarget = nil
		trigger.action.outSoundForCoalition(2,"cancel.ogg")
	end,
	isActive = function()
		if not resupplyTarget then return false end
		
		local targetzn = bc:getZoneByName(resupplyTarget)
		return targetzn:canRecieveSupply()
	end
})

attackTarget = nil
mc:trackMission({
	title = function() return "Attack "..attackTarget end,
	description = function() return "Destroy enemy forces at "..attackTarget end,
	messageStart = function() return "New mission: Attack "..attackTarget end,
	messageEnd = function() return "Mission ended: Attack "..attackTarget end,
	startAction = function() trigger.action.outSoundForCoalition(2,"ding.ogg") end,
	endAction = function() 
		attackTarget = nil 
		trigger.action.outSoundForCoalition(2,"cancel.ogg")
	end,
	isActive = function()
		if not attackTarget then return false end
		
		local targetzn = bc:getZoneByName(attackTarget)
		return targetzn.side == 1
	end
})

captureTarget = nil
mc:trackMission({
	title = function() return "Capture "..captureTarget end,
	description = function() return captureTarget.." is neutral. Capture it by delivering supplies" end,
	messageStart = function() return "New mission: Capture "..captureTarget end,
	messageEnd = function() return "Mission ended: Capture "..captureTarget end,
	startAction = function() trigger.action.outSoundForCoalition(2,"ding.ogg") end,
	endAction = function() 
		captureTarget = nil 
		trigger.action.outSoundForCoalition(2,"cancel.ogg")
	end,
	isActive = function()
		if not captureTarget then return false end
		
		local targetzn = bc:getZoneByName(captureTarget)
		return targetzn.side == 0 and targetzn.active
	end
})

function generateCaptureMission()
	if captureTarget ~= nil then return end
		
	local validzones = {}
	for _,v in ipairs(bc.zones) do
		if v.side == 0 and v.active then
			table.insert(validzones, v.zone)
		end
	end
	
	if #validzones == 0 then return end
	
	local choice = math.random(1, #validzones)
	if validzones[choice] then
		captureTarget = validzones[choice]
		return true
	end
end

function generateAttackMission()
	if attackTarget ~= nil then return end
		
	local validzones = {}
	for _,v in ipairs(bc.connections) do
		local to = bc:getZoneByName(v.to)
		local from = bc:getZoneByName(v.from)
		
		if from.side ~= to.side and from.side ~= 0  and to.side ~= 0 and from.active and to.active then
			if from.side == 1 then
				table.insert(validzones, from.zone)
			elseif to.side == 1 then
				table.insert(validzones, to.zone)
			end
		end
	end
	
	if #validzones == 0 then return end
	
	local choice = math.random(1, #validzones)
	if validzones[choice] then
		attackTarget = validzones[choice]
		return true
	end
end

function generateSupplyMission()
	if resupplyTarget ~= nil then return end
		
	local validzones = {}
	for _,v in ipairs(bc.zones) do
		if v.side == 2 and v:canRecieveSupply() then
			table.insert(validzones, v.zone)
		end
	end
	
	if #validzones == 0 then return end
	
	local choice = math.random(1, #validzones)
	if validzones[choice] then
		resupplyTarget = validzones[choice]
		return true
	end
end

timer.scheduleFunction(function(_, time)
	if generateCaptureMission() then
		return time+300
	else
		return time+120
	end
end, {}, timer.getTime() + 20)

timer.scheduleFunction(function(_, time)
	if generateAttackMission() then
		return time+300
	else
		return time+120
	end
end, {}, timer.getTime() + 40)

timer.scheduleFunction(function(_, time)
	if generateSupplyMission() then
		return time+300
	else
		return time+120
	end
end, {}, timer.getTime() + 60)

mc:init()

function respawnStatics()
	for i,v in pairs(cargoSpawns) do
		local farp = bc:getZoneByName(i)
		if farp then
			if farp.side==2 then
				for ix,vx in ipairs(v) do
					if not StaticObject.getByName(vx) then
						mist.respawnGroup(vx)
					end
				end
			else
				for ix,vx in ipairs(v) do
					local cr = StaticObject.getByName(vx)
					if cr then
						cr:destroy()
					end
				end
			end
		end
	end
	
	for i,v in pairs(farpSupply) do
		local farp = bc:getZoneByName(i)
		if farp then
			if farp.side==2 then
				for ix,vx in ipairs(v) do
					local gr = Group.getByName(vx)
					if not gr then
						mist.respawnGroup(vx)
					elseif gr:getSize() < gr:getInitialSize() then
						mist.respawnGroup(vx)
					end
				end
			else
				for ix,vx in ipairs(v) do
					local cr = Group.getByName(vx)
					if cr then
						cr:destroy()
					end
				end
			end
		end
	end
end

mist.scheduleFunction(respawnStatics, {}, timer.getTime() + 1, 30)

--- Function to check for player death and subtract a specific amount from the coalition 'bank'

local ev = {} 
ev.bc = bc
function ev:onEvent(event)
    if event.id ~= world.event.S_EVENT_UNIT_LOST then return end 
    if not event.initiator then return end 
    if not event.initiator.getPlayerName then return end 
    if not event.initiator:getPlayerName() then return end 
    
    trigger.action.outText("Player aircraft lost, 100 credits subtracted from coalition ", 10)
--	 trigger.action.outText("Player aircraft lost, 100 credits subtracted from coalition "..event.initiator:getCoalition(), 10) -- Version with coalition number included	
    self.bc:addFunds(event.initiator:getCoalition(),-100) 
end

world.addEventHandler(ev)
